# Tasks we use

The following tasks are mandatory to every project and should be available at any point. The tasks may do
nothing if appropriate.


## Project setup

### install

Side note: `install` has formerly be known as `setup`.

The install task will setup the project for you. It will install dependencies (npm, virtualenv, …), and
make sure an initial config exists.

You may need to update `local.yml` after initially running this tasks and then run `b5 update` to recreate
the config provided.

### update

When working on a project you may at some time intruduce changes that might break the installation
of the project for your colleges. This might include changing the database schema, add additional
configuration options, …

`b5 update` will use the necessary tools to make sure the project is up to date. This means for
example running database migrations. 

### clean

The clean task will remove any files installed by b5. This includes for example the node_modules-directory
intruduced by `npm install`.

## Assets building

### css

This task will build the CSS files necessary for your project. It will build these files once and then
exit. May use Sass or less for doing so.

### js

The js task will build any Javascript files inside your project. This may use Typescript or just webpack to
combine multiple files. It will exit after doing so.

### watch

The watch task will build CSS and Javascript files on every change. It will stay alive until canceled
using Ctrl+C.

## Deployment

### deploy

Takes on parameter: Server to deploy to (example: `b5 deploy staging`)

Will deploy all the changes from the local repository to the server. 

### deploy_install

Like `deploy` but will only setup the project on the server. It will not try to run tasks for
updating the project as these will fail (example: running database migrations without having configured
the database connection is a bad idea).

## Optional tasks

The following tasks are optional and may be available. We define how the tasks work so these optional tasks
work the same for all projects, if present.

TODO!

* docker
* import_production_db
* dbdump
* dbimport
* browsersync

